<?php
/*
Plugin Name: Footnotes for Wordpress
Plugin URI: http://www.mummila.net/nuudelisoppa/index.php/?page_id=974
Description: Provides [fnote]...[/fnote] tags to ease inserting footnotes. Based on <a href="http://duanegran.com/blog/?p=267">Duane Gran's version of Link Footnotes</a>.
Author: Jani Uusitalo
Version: 0.9
Author URI: http://www.mummila.net/marginaali/
*/


	
add_filter('the_content', 'footnote_content', 10);
add_filter('wp_head', 'footnote_css', 10);

function footnote_content($content)
{
	// the maximum length of shorthand version of the footnote (excluding the added hellipsis), used when forming the title attribute
	$jufn_excerptLength = 100;
	// footnote anchor links' titles; used as if it would say "permalink of this footnote"
	$jufn_footPermaTitle = "footnote permalink";
	// back-to-paragraph links' titles; used as if it would say "return to paragraph"
	$jufn_backToPTitle = "return to referencing paragraph";



	global $post;
	
	preg_match_all('/\[fnote\](.*?)\[\/fnote\]/si', $content, $fnotes, PREG_SET_ORDER);
	if(count($fnotes) > 0) {
		$postLink = get_permalink();
		$i = 1;
		foreach($fnotes as $fnote) {
			$footnotes[$i]->index = $i;
			$footnotes[$i]->note = str_replace('[fnote]', '', str_replace('[/fnote]', '', $fnote[0]));
			$footnotes[$i]->short = strip_tags(str_replace('[fnote]', '', str_replace('[/fnote]', '', $fnote[0])));
			if (strlen($footnotes[$i]->short) > $jufn_excerptLength) {
				$footnotes[$i]->short = substr($footnotes[$i]->short, 0, $jufn_excerptLength-1) . "&hellip;";
			}
			$content = str_replace($fnote[0], '<a id="fnote-' . $post->post_name . '-' . $i . '" href="'.$postLink.'#footnote-' . $post->post_name . '-' . $i . '" class="fnote" title="' . $footnoteString . $i . ': ' . $footnotes[$i]->short . '">' . $i . '</a>', $content);
			$i = $i+1;
		}
		$content .= "<ol class=\"footnotes\">\n";
		foreach($footnotes as $note) {
			$content .= "<li><a title=\"" . $jufn_footPermaTitle . "\" id=\"footnote-{$post->post_name}-{$note->index}\" href=\"$postLink#footnote-{$post->post_name}-{$note->index}\" class=\"footnote\">{$note->index}</a> {$note->note} <a title=\"" . $jufn_backToPTitle . "\" href=\"$postLink#fnote-{$post->post_name}-{$note->index}\" class=\"" . $backToPClass . "\">&para;</a></li>\n";
		}
		$content .= "</ol>\n";
	}
	return $content;
}

function footnote_css() {
  echo "
        <!-- footnote styles -->
        <style type='text/css'>
		ol.footnotes {
			margin-top: 3em;
			margin-bottom: 3em;
			font-size: .8em
		}
		ol.footnotes li {
			list-style: none;
		}

		a.fnote,
		a.fnote:link,
		a.fnote:active,
		a.fnote:visited,
		a.footnote,
		a.footnote:link,
		a.footnote:active,
		a.footnote:visited {
			font-size: .8em;
			font-variant:small-caps;
			vertical-align:super;
			text-decoration:none;
		}
		a.fnote:before,
		a.footnote:before {
			content:'['
		}
		a.fnote:after,
		a.footnote:after {
			content:']'
		}

		ol.footnotes a.footnote {
			font-size: 1em;
			vertical-align:baseline
		}
        </style>
        ";
}



?>